class RESTHome
  def request_with_instrumentation(method, path, options)
    ActiveSupport::Notifications.instrument("request.resthome", :client => self.class.name, method: method, path: path) do
      request_without_instrumentation(method, path, options)
    end
  end

  alias_method_chain :request, :instrumentation

  class LogSubscriber < ActiveSupport::LogSubscriber
    def request(event)
      info '%s (%.1fms) %s %s' % [event.payload[:client], event.duration, event.payload[:method].upcase, event.payload[:path]]
    end
  end
end

RESTHome::LogSubscriber.attach_to :resthome
